{%- from "linux/map.jinja" import system with context %}

{%- if system.sosreport.collect is defined or pillar['sosreport_collect'] is defined %}
{%- set collectDefaultOpts = {
      'nodeIp': grains.get('fqdn_ip4')[0],
      'port': '31337',
      'archiveName': 'sosreport_{0}'.format(grains.get('domain')),
      'reportWorkDir':  '/tmp/sosreport_collect_' + 9999|random_str } %}

{%- if system.sosreport.collect is defined %}
  {%- for key,value in system.sosreport.collect.items() %}
    {%- do collectDefaultOpts.update({ key: value }) %}
  {%- endfor %}
{%- endif %}
{%- if pillar['sosreport_collect'] is defined %}
  {%- for key,value in pillar['sosreport_collect'].items() %}
    {%- do collectDefaultOpts.update({ key: value }) %}
  {%- endfor %}
{%- endif %}

sosreport_tmp_collect_dir:
  file.directory:
    - name: {{ collectDefaultOpts['reportWorkDir'] }}
    - user: root

sosreport_send_script:
  file.managed:
  - name: {{ collectDefaultOpts['reportWorkDir'] }}/sosreport_collect.sh
  - source: salt://linux/files/sosreport_collect.sh
  - makedirs: true
  - user: root
  - mode: 755
  - template: jinja
  - require:
    - file: sosreport_tmp_collect_dir
  - defaults: |
    nodeIp: '{{ collectDefaultOpts['nodeIp'] }}'
    port: '{{ collectDefaultOpts['port'] }}'
    target: '{{ collectDefaultOpts['target'] }}'
    reportWorkDir: '{{ collectDefaultOpts['reportWorkDir'] }}'
    archiveName: '{{ collectDefaultOpts['archiveName'] }}'

sosreport_run:
  cmd.run:
    - name: {{ collectDefaultOpts['reportWorkDir'] }}/sosreport_collect.sh
    - require:
      - file: sosreport_send_script

{%- else %}
echo_unset_data:
  cmd.run:
  - name: echo "You are trying to collect Sosreport, for this pillar data sosreport.collect or pillar override sosreport_collect should be set. See README for sosreport.collect usage. Skipping."
{%- endif %}
